3feeb6084fc1daede5f7d83c9861253d25965d95
[virt-what.git] / virt-what.in
1 #!/bin/sh -
2 # @configure_input@
3 # Copyright (C) 2008-2011 Red Hat Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
18
19 # 'virt-what' tries to detect the type of virtualization being
20 # used (or none at all if we're running on bare-metal).  It prints
21 # out one or more lines each being a 'fact' about the virtualization.
22 #
23 # Please see also the manual page virt-what(1).
24 # This script should be run as root.
25 #
26 # The following resources were useful in writing this script:
27 # . http://dmo.ca/blog/detecting-virtualization-on-linux/
28
29 # Do not allow unset variables, and set defaults.
30 set -u
31 root=''
32 skip_qemu_kvm=false
33
34 VERSION="@VERSION@"
35
36 fail() {
37     echo "virt-what: $1" >&2
38     exit 1
39 }
40
41 usage() {
42     echo "virt-what [options]"
43     echo "Options:"
44     echo "  --help          Display this help"
45     echo "  --version       Display version and exit"
46     exit 0
47 }
48
49 # Handle the command line arguments, if any.
50
51 TEMP=$(getopt -o v --long help --long version --long test-root: -n 'virt-what' -- "$@")
52 if [ $? != 0 ]; then exit 1; fi
53 eval set -- "$TEMP"
54
55 while true; do
56     case "$1" in
57         --help) usage ;;
58         --test-root)
59             # Deliberately undocumented: used for 'make check'.
60             root="$2"
61             shift 2
62             ;;
63         -v|--version) echo "$VERSION"; exit 0 ;;
64         --) shift; break ;;
65         *) fail "internal error ($1)" ;;
66     esac
67 done
68
69 # Add /sbin and /usr/sbin to the path so we can find system
70 # binaries like dmidecode.
71 # Add /usr/libexec to the path so we can find the helper binary.
72 prefix=@prefix@
73 exec_prefix=@exec_prefix@
74 PATH="${root}@libexecdir@:${root}/sbin:${root}/usr/sbin:${PATH}"
75
76 # Check we're running as root.
77 EFFUID=$(id -u) || fail "failed to get current user id"
78
79 if [ "x$root" = "x" ] && [ "$EFFUID" -ne 0 ]; then
80     fail "this script must be run as root"
81 fi
82
83 # Many fullvirt hypervisors give an indication through CPUID.  Use the
84 # helper program to get this information.
85
86 cpuid=$(virt-what-cpuid-helper)
87
88 # Check for various products in the BIOS information.
89 # Note that dmidecode doesn't exist on non-PC architectures.  On these,
90 # this will return an error which is ignored (error message redirected
91 # into $dmi variable).
92
93 dmi=$(LANG=C dmidecode 2>&1)
94
95 # Architecture.
96 # Note for the purpose of testing, we only call uname with -p option.
97
98 arch=$(uname -p)
99
100 # Check for VMware.
101 # cpuid check added by Chetan Loke.
102
103 if [ "$cpuid" = "VMwareVMware" ]; then
104     echo vmware
105 elif echo "$dmi" | grep -q 'Manufacturer: VMware'; then
106     echo vmware
107 fi
108
109 # Check for Hyper-V.
110 # http://blogs.msdn.com/b/sqlosteam/archive/2010/10/30/is-this-real-the-metaphysics-of-hardware-virtualization.aspx
111 if [ "$cpuid" = "Microsoft Hv" ]; then
112     echo hyperv
113 fi
114
115 # Check for VirtualPC.
116 # The negative check for cpuid is to distinguish this from Hyper-V
117 # which also has the same manufacturer string in the SM-BIOS data.
118 if [ "$cpuid" != "Microsoft Hv" ] &&
119     echo "$dmi" | grep -q 'Manufacturer: Microsoft Corporation'; then
120     echo virtualpc
121 fi
122
123 # Check for VirtualBox.
124 # Added by Laurent Léonard.
125 if echo "$dmi" | grep -q 'Manufacturer: innotek GmbH'; then
126     echo virtualbox
127 fi
128
129 # Check for OpenVZ / Virtuozzo.
130 # Added by Evgeniy Sokolov.
131 # /proc/vz - always exists if OpenVZ kernel is running (inside and outside
132 # container)
133 # /proc/bc - exists on node, but not inside container.
134
135 if [ -d "${root}/proc/vz" -a ! -d "${root}/proc/bc" ]; then
136     echo openvz
137 fi
138
139 # Check for LXC containers
140 # http://www.freedesktop.org/wiki/Software/systemd/ContainerInterface
141 # Added by Marc Fournier
142
143 if [ -e "${root}/proc/1/environ" ] &&
144     cat "${root}/proc/1/environ" | tr '\000' '\n' | grep -Eiq '^container='; then
145     echo lxc
146 fi
147
148 # Check for Linux-VServer
149 if cat "${root}/proc/self/status" | grep -q "VxID: [0-9]*"; then
150     echo linux_vserver
151     if grep -q "VxID: 0$" "${root}/proc/self/status"; then
152         echo linux_vserver-host
153     else
154         echo linux_vserver-guest
155     fi
156 fi
157
158 # Check for UML.
159 # Added by Laurent Léonard.
160 if grep -q 'UML' "${root}/proc/cpuinfo"; then
161     echo uml
162 fi
163
164 # Check for IBM PowerVM Lx86 Linux/x86 emulator.
165 if grep -q '^vendor_id.*PowerVM Lx86' "${root}/proc/cpuinfo"; then
166     echo powervm_lx86
167 fi
168
169 # Check for Hitachi Virtualization Manager (HVM) Virtage logical partitioning.
170 if echo "$dmi" | grep -q 'Manufacturer.*HITACHI' &&
171    echo "$dmi" | grep -q 'Product.* LPAR'; then
172     echo virtage
173 fi
174
175 # Check for IBM SystemZ.
176 if grep -q '^vendor_id.*IBM/S390' "${root}/proc/cpuinfo"; then
177     echo ibm_systemz
178     if [ -f "${root}/proc/sysinfo" ]; then
179         if grep -q 'VM.*Control Program.*z/VM' "${root}/proc/sysinfo"; then
180             echo ibm_systemz-zvm
181         elif grep -q '^LPAR' "${root}/proc/sysinfo"; then
182             echo ibm_systemz-lpar
183         else
184             # This is unlikely to be correct.
185             echo ibm_systemz-direct
186         fi
187     fi
188 fi
189
190 # Check for Parallels.
191 if echo "$dmi" | grep -q 'Vendor: Parallels'; then
192     echo parallels
193     skip_qemu_kvm=true
194 fi
195
196 # Check for Xen.
197
198 if [ "$cpuid" = "XenVMMXenVMM" ]; then
199     echo xen; echo xen-hvm
200     skip_qemu_kvm=true
201 elif [ -d "${root}/proc/xen" ]; then
202     echo xen
203     if grep -q "control_d" "${root}/proc/xen/capabilities" 2>/dev/null; then
204         echo xen-dom0
205     else
206         echo xen-domU
207     fi
208     skip_qemu_kvm=true
209 elif [ -f "${root}/sys/hypervisor/type" ] &&
210     grep -q "xen" "${root}/sys/hypervisor/type"; then
211     # Ordinary kernel with pv_ops.  There does not seem to be
212     # enough information at present to tell whether this is dom0
213     # or domU.  XXX
214     echo xen
215 elif [ "$arch" = "ia64" ]; then
216     if [ -d "${root}/sys/bus/xen" -a ! -d "${root}/sys/bus/xen-backend" ]; then
217         # PV-on-HVM drivers installed in a Xen guest.
218         echo xen
219         echo xen-hvm
220     else
221         # There is no virt leaf on IA64 HVM.  This is a last-ditch
222         # attempt to detect something is virtualized by using a
223         # timing attack.
224         virt-what-ia64-xen-rdtsc-test > /dev/null 2>&1
225         case "$?" in
226             0) ;; # not virtual
227             1) # Could be some sort of virt, or could just be a bit slow.
228                 echo virt
229         esac
230     fi
231 fi
232
233 # Check for QEMU/KVM.
234 #
235 # Parallels exports KVMKVMKVM leaf, so skip this test if we've already
236 # seen that it's Parallels.  Xen uses QEMU as the device model, so
237 # skip this test if we know it is Xen.
238
239 if ! "$skip_qemu_kvm"; then
240     if [ "$cpuid" = "KVMKVMKVM" ]; then
241         echo kvm
242     else
243         # XXX This is known to fail for qemu with the explicit -cpu
244         # option, since /proc/cpuinfo will not contain the QEMU
245         # string.  The long term fix for this would be to export
246         # another CPUID leaf for non-accelerated qemu.
247         if grep -q 'QEMU' "${root}/proc/cpuinfo"; then
248             echo qemu
249         fi
250     fi
251 fi
252
253 # Check for Docker.
254 if [ -f "${root}/.dockerinit" ]; then
255         echo docker
256 fi